
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>lib.tcl / 憋错料</title>

    <meta name="description" content="lib.tcl #********************************************************************# 功能描述:定义公共的函数# 依赖关系:依赖于全局aitools工具包(因为存在对数据库的操作)# 调用方法:无# 数据流向:无# 创建人:wengdan# 创建日期:20151016# 修改历史:# 序号 日期 修改人 修改原因 修改内容#***********************************************************">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">lib.tcl</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>#********************************************************************<br /># 功能描述：定义公共的函数<br /># 依赖关系：依赖于全局aitools工具包（因为存在对数据库的操作）<br /># 调用方法：无<br /># 数据流向：无<br /># 创建人：wengdan<br /># 创建日期：20151016<br /># 修改历史：<br />#      序号    日期    修改人          修改原因            修改内容<br />#*********************************************************************</p>
<p># include.tcl定义了一些公共变量<br />#source /crm/crmwk/aiomnivision/bin/include.tcl</p>
<p>####################################################################################################################################################################<br />#程序执行函数<br />#################</p>
<p>#*********************************************************************<br /># 功能描述：执行sql，执行后将返回成功失败标志，并提交数据库<br /># 数据流向：无<br /># 参数说明：<br />#               sqlStr：                表示将执行的sql<br />#               errCode：               表示sql执行的返回码，在一个程序里面应该唯一（递增），用于唯一标示执行的sql<br />#<br /># 返回值说明：<br />#               -1 执行失败<br />#               0 执行成功<br />#*********************************************************************<br />proc exeSql {p_sqlStr p_errCode} {<br />        set rt [ _exeSql $p_sqlStr $p_errCode 1 1 ]<br />        return $rt<br />}</p>
<p>#*********************************************************************<br /># 功能描述：执行sql（原型）<br /># 数据流向：无<br /># 参数说明：<br />#               sqlStr：                表示将执行的sql<br />#               errCode：               表示sql执行的返回码，在一个程序里面应该唯一（递增），用于唯一标示执行的sql<br />#               isReturn：      表示sql执行是否判断aidb_sql的执行结果并返回（如果返回-1将导致程序结束运行），默认返回<br />#                               1:表示返回错误 0:表示不返回错误<br />#               isCommit：      表示sql执行后是否提交<br />#                               1:表示执行完后立即提交 0:表示不立即提交<br />#<br /># 返回值说明：<br />#               -1 执行失败<br />#               0 执行成功<br />#*********************************************************************<br />proc _exeSql {p_sqlStr p_errCode p_isReturn p_isCommit} {<br />        global conn<br />        global handle</p>
<p>traceLog "=======       开始执行SQL语句 =======" ""<br />        traceLog ${p_sqlStr} ""<br />        if [catch { aidb_sql ${handle} ${p_sqlStr} } errmsg ] {</p>
<p>traceLog [string range ${errmsg} 30 [string length ${errmsg}] ] ${p_errCode}<br />            set systime [exec date "+%Y-%m-%d %H:%M:%S"]<br />            puts "\[${systime}\] -&gt;  ${p_sqlStr} "<br />            puts "\[${systime}\] -&gt; ERROR:[string range ${errmsg} 30 [string length ${errmsg}] ] LINE=${p_errCode}"</p>
<p>if { ${p_isReturn} == 1 } {<br />                return -1<br />            }<br />  }<br />  if { ${p_isCommit} == 1 } {<br />        aidb_commit ${conn}<br />  }<br />  traceLog "=======     SQL语句执行结束 =======" ""<br />        return 0<br />}</p>
<p>#*********************************************************************<br /># 功能描述：检查某表是否在数据库中存在<br /># 数据流向：无<br /># 参数说明：检查的表名<br /># 返回值说明：<br />#               0 不存在<br />#               1 存在<br />#               -1 检查出错<br />#*********************************************************************<br />proc isTabExist {p_tabName} {<br />        global conn<br />        global handle</p>
<p>set tabNm [string toupper $p_tabName]<br />        # 检查syscat.tables系统表<br />        # 20100421,[email&#160;protected]增加对数据库当前SCHEMA的判断<br />        set sqlstat "select count(1) from syscat.tables where tabname=‘$tabNm‘ and tabschema = current schema with ur"<br />        if [catch {aidb_sql $handle $sqlstat} errmsg] {<br />                trace_sql $errmsg  1000<br />                # 如果语句执行出错，返回-1<br />                return -1<br />        } else {<br />                set v [aidb_fetch $handle ]<br />                aidb_commit $conn<br />                aidb_close $handle<br />                set handle [aidb_open $conn]<br />                if {$v != 1} {<br />                        return 0<br />                } else {<br />                        return 1<br />                }<br />        }<br />}<br />####################################################################################################################################################################<br />#日期函数</p>
<p>#*********************************************************************<br /># 功能描述：1.1、获取参数日期yyyymmdd格式<br /># 参数说明：yyyy-mm-dd<br /># 返回值说明： 参数月[日期]，格式：yyyymmdd<br />#*********************************************************************<br />proc get_yyyymmdd {p_optime} {<br />        set year 0<br />        set month 0<br />        set day 0</p>
<p>scan $p_optime "%04s-%02s-%02s" year month day<br />        return ${year}${month}${day}<br />}</p>
<p>#*********************************************************************<br /># 功能描述：1.2、获取参数日期yyyymm格式<br /># 参数说明：yyyy-mm-dd<br /># 返回值说明： 参数月[日期]，格式：yyyymm<br />#*********************************************************************<br />proc get_yyyymm {p_optime} {<br />        set year 0<br />        set month 0</p>
<p>scan $p_optime "%04s-%02s" year month <br />        return ${year}${month}<br />}</p>
<p>#*********************************************************************<br /># 功能描述：1.3、获取参数日期yyyy-mm格式<br /># 参数说明：yyyy-mm-dd<br /># 返回值说明： 参数月[日期]，格式：yyyy-mm<br />#*********************************************************************<br />proc get_l_yyyymm {p_optime} {<br />        set year 0<br />        set month 0</p>
<p>scan $p_optime "%04s-%02s" year month <br />        return ${year}-${month}<br />}</p>
<p>#*********************************************************************<br /># 功能描述：1.4、获取参数日期的年 <br /># 参数说明：yyyy-mm-dd<br /># 返回值说明： 参数月[日期]所在年，格式：yyyy<br />#*********************************************************************<br />proc get_yyyy {p_optime} {<br />        set year 0</p>
<p>scan $p_optime "%04s" year<br />        return ${year}<br />}</p>
<p>#*********************************************************************<br /># 功能描述：1.5、获取某日所在月的总天数<br /># 数据流向：无<br /># 参数说明：yyyy-mm[-dd]<br /># 返回值说明： 参数月[日期]所在月的总天数，格式：dd<br />#*********************************************************************<br />proc get_days {p_optime} {<br />        set year 0<br />        set month 0</p>
<p>scan $p_optime "%04s-%02s" year month<br />        set cal [ exec cal $month $year ]<br />        set lastMday [lindex $cal end]<br />        return ${lastMday}<br />}</p>
<p>#*********************************************************************<br /># 功能描述：1.6、获取当月最后一天的日期<br /># 参数说明：yyyy-mm[-dd]<br /># 返回值说明：参数月[日期]所在月的最后一天的日期，格式yyyy-mm-dd<br />#*********************************************************************<br />proc get_l_ymds {p_optime} {<br />        set year 0<br />        set month 0</p>
<p>scan $p_optime "%04s-%02s" year month<br />        set lastMday [ get_days $p_optime ]<br />        return ${year}-${month}-${lastMday}<br />}</p>
<p>#*********************************************************************<br /># 功能描述：1.7、获取当月最后一天的日期<br /># 参数说明：yyyy-mm[-dd]<br /># 返回值说明：参数月[日期]所在月的最后一天的日期，格式yyyymmdd<br />#*********************************************************************<br />proc get_ymds {p_optime} {<br />        set year 0<br />        set month 0</p>
<p>scan $p_optime "%04s-%02s" year month<br />        set lastMday [ get_days $p_optime ]<br />        return ${year}${month}${lastMday}<br />}</p>
<p>#*********************************************************************<br /># 功能描述：2.1、获取某日的前一天日期<br /># 参数说明：yyyy-mm-dd<br /># 返回值说明： 基准日期的前一天日期，格式为yyyy-mm-dd<br />#*********************************************************************<br />proc get_l_pyyyymmdd {p_optime} {<br />        set year 0<br />        set month 0<br />        set day 0<br />        scan $p_optime "%04d-%02d-%02d" year month day</p>
<p>if { $day == 1 &amp;&amp; $month == 1} {<br />                # 返回上年12月31日<br />                set day 31<br />                set month 12<br />                set year [expr $year -1]<br />        } elseif {$day == 1} {<br />                # 返回前月最后一天<br />                set month [expr $month - 1]<br />                set cal [exec cal $month $year]<br />                set day [lindex $cal end]<br />        } else {<br />                # 返回同年同月前一天<br />                set day [expr $day - 1]<br />        }</p>
<p>set month [format "%02s" $month]<br />        set day [format "%02s" $day]</p>
<p>return $year-$month-$day<br />}</p>
<p>#*********************************************************************<br /># 功能描述：2.2、获取某日的前一天日期<br /># 参数说明：yyyy-mm-dd<br /># 返回值说明： 基准日期的前一天日期，格式为yyyymmdd<br />#*********************************************************************<br />proc get_pyyyymmdd {p_optime} {<br />        set year 0<br />        set month 0<br />        set day 0</p>
<p>set tmp_optime [ get_l_pyyyymmdd $p_optime ]</p>
<p>scan $tmp_optime "%04s-%02s-%02s" year month day</p>
<p>return ${year}${month}${day}<br />}</p>
<p>#*********************************************************************<br /># 功能描述：2.3、获取某日的前一天的年月<br /># 参数说明：yyyy-mm-dd<br /># 返回值说明： 基准日期的前一天的年月，格式为yyyy-mm<br />#*********************************************************************<br />proc get_l_pyyyymm {p_optime} {<br />        set year 0<br />        set month 0</p>
<p>set tmp_optime [ get_l_pyyyymmdd $p_optime ]</p>
<p>scan $tmp_optime "%04s-%02s" year month</p>
<p>return ${year}-${month}<br />}</p>
<p>#*********************************************************************<br /># 功能描述：2.4、获取某日的前一天的年月<br /># 参数说明：yyyy-mm-dd<br /># 返回值说明： 基准日期的前一天的年月，格式为yyyymm<br />#*********************************************************************<br />proc get_pyyyymm {p_optime} {<br />        set year 0<br />        set month 0</p>
<p>set tmp_optime [ get_l_pyyyymmdd $p_optime ]</p>
<p>scan $tmp_optime "%04s-%02s" year month</p>
<p>return ${year}${month}<br />}</p>
<p>#*********************************************************************<br /># 功能描述：2.5、获取某日的前一天的年<br /># 参数说明：yyyy-mm-dd<br /># 返回值说明： 基准日期的前一天的年，格式为yyyy<br />#*********************************************************************<br />proc get_pyyyy {p_optime} {<br />        set year 0</p>
<p>set tmp_optime [ get_l_pyyyymmdd $p_optime ]</p>
<p>scan $tmp_optime "%04s" year</p>
<p>return ${year}<br />}</p>
<p>#*********************************************************************<br /># 功能描述：3.1、获取前月最后一日 日期<br /># 参数说明：yyyy-mm-dd<br /># 返回值说明： 基准日期的前月最后一天的日期，格式为yyyy-mm-dd<br />#*********************************************************************<br />proc get_l_lymds {p_optime} {<br />        set year 0<br />        set month 0<br />        set day 0</p>
<p>scan $p_optime "%04s-%02s-%02s" year month day<br />        set tmp_optime [ get_l_pyyyymmdd ${year}-${month}-01 ]</p>
<p>scan $tmp_optime "%04s-%02s-%02s" year month day<br />        return ${year}-${month}-${day}<br />}</p>
<p>#*********************************************************************<br /># 功能描述：3.2、获取前月最后一日 日期<br /># 参数说明：yyyy-mm-dd<br /># 返回值说明： 基准日期的前月最后一天的日期，格式为yyyymmdd<br />#*********************************************************************<br />proc get_lymds {p_optime} {<br />        set year 0<br />        set month 0<br />        set day 0</p>
<p>scan $p_optime "%04s-%02s-%02s" year month day<br />        set tmp_optime [ get_l_pyyyymmdd ${year}-${month}-01 ]</p>
<p>scan $tmp_optime "%04s-%02s-%02s" year month day<br />        return ${year}${month}${day}<br />}</p>
<p>#*********************************************************************<br /># 功能描述：3.3、获取前月最后一日 日期<br /># 参数说明：yyyy-mm-dd<br /># 返回值说明： 基准日期的前月最后一天的日期，格式为yyyy-mm<br />#*********************************************************************<br />proc get_l_lyyyymm {p_optime} {<br />        set year 0<br />        set month 0<br />        set day 0</p>
<p>scan $p_optime "%04s-%02s-%02s" year month day<br />        set tmp_optime [ get_l_pyyyymmdd ${year}-${month}-01 ]</p>
<p>scan $tmp_optime "%04s-%02s-%02s" year month day<br />        return ${year}-${month}<br />}</p>
<p>#*********************************************************************<br /># 功能描述：3.4、获取前月最后一日 日期<br /># 参数说明：yyyy-mm-dd<br /># 返回值说明： 基准日期的前月最后一天的日期，格式为yyyymm<br />#*********************************************************************<br />proc get_lyyyymm {p_optime} {<br />        set year 0<br />        set month 0<br />        set day 0</p>
<p>scan $p_optime "%04s-%02s-%02s" year month day<br />        set tmp_optime [ get_l_pyyyymmdd ${year}-${month}-01 ]</p>
<p>scan $tmp_optime "%04s-%02s-%02s" year month day<br />        return ${year}${month}<br />}</p>
<p>#*********************************************************************<br /># 功能描述：3.5、获取前月最后一日 年<br /># 参数说明：yyyy-mm-dd<br /># 返回值说明： 基准日期的前月最后一天的日期，格式为yyyy<br />#*********************************************************************<br />proc get_lyyyy {p_optime} {<br />        set year 0<br />        set month 0<br />        set day 0</p>
<p>scan $p_optime "%04s-%02s-%02s" year month day<br />        set tmp_optime [ get_l_pyyyymmdd ${year}-${month}-01 ]</p>
<p>scan $tmp_optime "%04s-%02s-%02s" year month day<br />        return ${year}<br />}</p>
<p>#*********************************************************************<br /># 功能描述：3.6、上月同期 <br /># 参数说明：yyyy-mm-dd<br /># 返回值说明： 参数日期的上月同期，格式为yyyy-mm-dd<br />#*********************************************************************<br />proc get_l_lmymd {p_optime} {<br />        set year 0<br />        set month 0<br />        set day 0<br />        scan $p_optime "%04d-%02d-%02d" year month day<br />        set lastmday [ get_days $p_optime ]</p>
<p>#若是1月<br />        if { $month == 1} {<br />                # 返回上年12月<br />                set month 12<br />                set year [expr $year -1]<br />        #若是3月末<br />        } elseif {$month == 3 &amp;&amp; $day &gt;=29 } {<br />                set month [expr $month -1]</p>
<p>#返回上月最后一天<br />                set day [ get_days ${year}-${month}-01 ]<br />        #若是月末<br />        } elseif {$day == $lastmday} {<br />                set month [expr $month -1]</p>
<p>#返回上月最后一天<br />                set day [ get_days ${year}-${month}-01 ]<br />        } else {<br />                 set month [expr $month -1]<br />        }</p>
<p>set month [format "%02s" $month]<br />        set day [format "%02s" $day]</p>
<p>return ${year}-${month}-${day}<br />}</p>
<p>#*********************************************************************<br /># 功能描述：3.7、上月同期 <br /># 参数说明：yyyy-mm-dd<br /># 返回值说明： 参数日期的上月同期，格式为yyyymmdd<br />#*********************************************************************<br />proc get_lmymd {p_optime} {<br />        set year 0<br />        set month 0<br />        set day 0</p>
<p>set tmp_optime [ get_l_lmymd ${p_optime} ]        <br />        scan $tmp_optime "%04s-%02s-%02s" year month day</p>
<p>return ${year}${month}${day}<br />}</p>
<p>#*********************************************************************<br /># 功能描述：获取某日的前若干天日期<br /># 数据流向：无<br /># 参数说明：<br />#               1 基准日期p_optime，格式yyyy-mm-dd<br />#               2 相隔天数p_delta，格式数字，无前导0<br /># 返回值说明：<br />#               基准日期的前p_delta天日期，格式为yyyy-mm-dd<br />#*********************************************************************<br />proc get_l_Npyyyymmdd {p_optime p_delta} {<br />        set year 0<br />        set month 0<br />        set day 0</p>
<p>set tmp_optime $p_optime<br />        for { set i 1 } { $i &lt;= $p_delta } { incr i } {<br />                set tmp_optime [ get_l_pyyyymmdd $tmp_optime ]<br />        }<br />        return $tmp_optime<br />}</p>
<p>#*********************************************************************<br /># 功能描述：获取某日的前若干天日期<br /># 数据流向：无<br /># 参数说明：<br />#               1 基准日期p_optime，格式yyyy-mm-dd<br />#               2 相隔天数p_delta，格式数字，无前导0<br /># 返回值说明：<br />#               基准日期的前p_delta天日期，格式为yyyymmdd<br />#*********************************************************************<br />proc get_Npyyyymmdd {p_optime p_delta} {<br />        set year 0<br />        set month 0<br />        set day 0</p>
<p>set tmp_optime $p_optime<br />        for { set i 1 } { $i &lt;= $p_delta } { incr i } {<br />                set tmp_optime [ get_l_pyyyymmdd $tmp_optime ]<br />        }</p>
<p>scan $tmp_optime "%04s-%02s-%02s" year month day<br />        return ${year}${month}${day}<br />}</p>
<p>####################################################################################################################################################################</p>
<p>##*********************************************************************<br />## 功能描述：日期格式转化<br />## 数据流向：无<br />## 参数说明：<br />##               1 p_optime 要转化的日期，月、日数字必须带前导0<br />##               2 p_fmt_src 原始日期格式（yyyy-mm-dd,yyyymmdd）<br />##               3 p_fmt_obj 目标日期格式（yyyy，-，mm，dd4种元素的组合，如yyyy-mm-dd,yyyy-mm,yyyy,mm,dd,yyyymmdd,yyyymm,mmdd）<br />## 返回值说明：<br />##               按p_fmt_obj的格式返回p_optime<br />##*********************************************************************<br />#proc formatDate { p_optime p_fmt_src p_fmt_obj } {<br />#        set year 0<br />#        set month 0<br />#        set day 0<br />#<br />#        # 根据原格式析取<br />#        if { $p_fmt_src == "yyyy-mm-dd" }       {<br />#                scan $p_optime "%04s-%02s-%02s" year month day<br />#        } elseif { $p_fmt_src == "yyyymmdd" } {<br />#                scan $p_optime "%04s%02s%02s" year month day<br />#        } else {<br />#                traceLog "function formatDate() 不支持源日期格式描述${p_fmt_src}" "0501"<br />#                return ""<br />#        }<br />#<br />#        # 如果month、day为空，则默认01<br />#        if {$day == "" || $day == 0 || $day == 00 } { set day [ format "%02d" 1 ] }<br />#        if {$month == "" || $month == 0 || $month == 00} { set month [ format "%02d" 1 ] }<br />#<br />#        # 根据结果格式转化<br />#        if { $p_fmt_obj == "yyyymmdd" } {<br />#                set v ${year}${month}${day}<br />#        } elseif { $p_fmt_obj == "yyyymm" } {<br />#                set v ${year}${month}<br />#        } elseif { $p_fmt_obj == "yyyy-mm-dd" } {<br />#                set v ${year}-${month}-${day}<br />#        } elseif { $p_fmt_obj == "yyyy-mm" } {<br />#                set v ${year}-${month}<br />#        } elseif { $p_fmt_obj == "yyyy" } {<br />#                set v ${year}<br />#        } elseif { $p_fmt_obj == "mm" } {<br />#                set v ${month}<br />#        } elseif { $p_fmt_obj == "dd" } {<br />#                set v ${day}<br />#        } elseif { $p_fmt_obj == "mm-dd" } {<br />#                set v ${month}-${day}<br />#        } elseif { $p_fmt_obj == "mmdd" } {<br />#                set v ${month}${day}<br />#        } else {<br />#                traceLog "function formatDate() 不支持目标日期格式描述${p_fmt_src}" "0501"<br />#                return ""<br />#        }<br />#<br />#        # 返回结果<br />#        return ${v}<br />#}<br />#<br />#<br />#<br />##*********************************************************************<br />## 功能描述：获取某日的前若干天日期<br />## 数据流向：无<br />## 参数说明：<br />##               1 基准日期p_optime，格式yyyy-mm-dd<br />##               2 相隔天数p_delta，格式数字，无前导0<br />## 返回值说明：<br />##               基准日期的前p_delta天日期，格式为yyyy-mm-dd<br />##*********************************************************************<br />#proc getPreDays {p_optime p_delta} {<br />#        set year 0<br />#        set month 0<br />#        set day 0<br />#<br />#        set tmp_optime $p_optime<br />#        for { set i 1 } { $i &lt;= $p_delta } { incr i } {<br />#                set tmp_optime [ getPreDay $tmp_optime ]<br />#        }<br />#        return $tmp_optime<br />#}<br />#<br />##*********************************************************************<br />## 功能描述：获取某日的后一天日期<br />## 数据流向：无<br />## 参数说明：yyyy-mm-dd<br />## 返回值说明：<br />##               基准日期的后一天日期，格式为yyyy-mm-dd<br />##*********************************************************************<br />#proc getNextDay {p_optime} {<br />#        set year 0<br />#        set month 0<br />#        set day 0<br />#        scan $p_optime "%04d-%02d-%02d" year month day<br />#        set lastMday [ getMonthDays $p_optime ]<br />#        if { $day == 31 &amp;&amp; $month == 12} {<br />#                # 返回下年1月1日<br />#                set day 01<br />#                set month 01<br />#                set year [expr $year + 1]<br />#        } elseif {$day == $lastMday} {<br />#                # 返回下月第一天<br />#                set month [expr $month + 1]<br />#                set day 01<br />#        } else {<br />#                # 返回同年同月后一天<br />#                set day [expr $day + 1]<br />#        }<br />#        set month [format "%02d" $month]<br />#        set day [format "%02d" $day]<br />#<br />#        return $year-$month-$day<br />#}<br />#<br />##*********************************************************************<br />## 功能描述：获取某日的后若干天日期<br />## 数据流向：无<br />## 参数说明：<br />##               1 基准日期p_optime，格式yyyy-mm-dd<br />##               2 相隔天数p_delta，格式数字，无前导0<br />## 返回值说明：<br />##               基准日期的后p_delta天日期，格式为yyyy-mm-dd<br />##*********************************************************************<br />#proc getNextDays {p_optime p_delta} {<br />#        set year 0<br />#        set month 0<br />#        set day 0<br />#<br />#        set tmp_optime $p_optime<br />#        for {set i $1 } { $i &lt;= $p_delta } { incr i } {<br />#                set tmp_optime [ getNextDay $tmp_optime ]<br />#        }<br />#        return $tmp_optime<br />#}<br />#<br />##*********************************************************************<br />## 功能描述：获取前月最后一天日期<br />## 数据流向：无<br />## 参数说明：<br />##               1 基准日期p_optime，格式yyyy-mm-dd<br />## 返回值说明：<br />##               基准日期的前月最后一天的日期，格式为yyyy-mm-dd<br />##*********************************************************************<br />#proc getLastPMday {p_optime} {<br />#        set year 0<br />#        set month 0<br />#        set day 0<br />#<br />#        scan $p_optime "%04s-%02s-%02s" year month day<br />#        set tmp_optime [ getPreDay ${year}-${month}-01 ]<br />#        return $tmp_optime<br />#}<br />##*********************************************************************<br />## 功能描述：获取后月一号日期<br />## 数据流向：无<br />## 参数说明：<br />##               1 基准日期p_optime，格式yyyy-mm-dd<br />## 返回值说明：<br />##               基准日期的后月第一天的日期，格式为yyyy-mm-dd<br />##*********************************************************************<br />#proc getFirstNextMday {p_optime} {<br />#        set lastMday [ getLastMday $p_optime ]<br />#        set firstNextMday [ getNextDay $lastMday ]<br />#        return $firstNextMday<br />#}<br />#<br />#<br />##*********************************************************************<br />## 功能描述：获取某日的星期数<br />## 数据流向：无<br />## 参数说明：<br />##               1 基准日期p_optime，格式yyyy-mm-dd<br />## 返回值说明：<br />##               基准日期的星期数：1-7<br />##*********************************************************************<br />#proc getWeekDay {p_optime} {<br />#          set year 0<br />#          set month 0<br />#          set day 0<br />#          scan $p_optime "%04d-%2d-%2d" year month day<br />#          set wd [ exec cal $month $year  | awk "\{for(i=1;i&lt;=NF;i++)\{if(\$i==$day &amp;&amp; NR&gt;3)\{print i\}else if(\$i==$day)\{print 7-NF+i \}\}\}" ]<br />#          set wd [ expr (${wd}-1+7) % 7 ]<br />#          if {$wd == 0} {<br />#                set wd 7<br />#          }<br />#          return $wd<br />#}<br />#<br />##*********************************************************************<br />## 功能描述：获取前日的星期数<br />## 数据流向：无<br />## 参数说明：<br />##               1 基准日期p_optime，格式yyyy-mm-dd<br />## 返回值说明：<br />##               基准日期前一日的星期数：1-7<br />##*********************************************************************<br />#proc getPreWeekDay {p_optime} {<br />#          set pre_day [ getPreDay $p_optime ]<br />#          set wd [ getWeekDay $pre_day ]<br />#          return $wd<br />#}<br />#<br />##*********************************************************************<br />## 功能描述：根据逻辑表空间名称获取实际表空间名称<br />## 数据流向：无<br />## 参数说明：逻辑表空间名称<br />## 返回值说明：<br />##               实际表空间名称<br />##*********************************************************************<br />#proc getTbsName {p_tbsName} {<br />#        return ${g::TBSMAP($p_tbsName)}<br />#}<br />#<br />##*********************************************************************<br />## 功能描述：根据用户名密码配置获取相应类型的用户名和密码<br />## 数据流向：无<br />## 参数说明：类型名，如<br />## 返回值说明：<br />##               用户名<br />## 备注：略，tcl程序不需要，在tcl调度程序中包含了统一的用户名密码获取方法<br />##*********************************************************************<br />#proc getUserPass {p_type} {<br />#<br />#}<br />#<br />##*********************************************************************<br />## 功能描述：根据用户名密码配置获取相应类型的密码<br />## 数据流向：无<br />## 参数说明：类型名<br />## 返回值说明：<br />##               密码<br />## 备注：略，tcl程序不需要，在tcl调度程序中包含了统一的用户名密码获取方法<br />##*********************************************************************<br />#proc getPassword {p_type } {<br />#<br />#}<br />#<br />#<br />#<br />##*********************************************************************<br />## 功能描述：检查某表是否在数据库中存在<br />## 数据流向：无<br />## 参数说明：检查的表名<br />## 返回值说明：<br />##               0 不存在<br />##               1 存在<br />##               -1 检查出错<br />##*********************************************************************<br />#proc isTabExist2 {p_schema p_tabName} {<br />#        global conn<br />#        global handle<br />#<br />#        set tabNm  [string toupper $p_tabName]<br />#        set schema [string toupper $p_schema]<br />#        # 检查syscat.tables系统表<br />#        set sqlstat "select count(1) from syscat.tables where tabname=‘$tabNm‘ and tabschema = ‘$schema‘ with ur"<br />#        if [catch {aidb_sql $handle $sqlstat} errmsg] {<br />#                trace_sql $errmsg  1000<br />#                # 如果语句执行出错，返回-1<br />#                return -1<br />#        } else {<br />#                set v [aidb_fetch $handle ]<br />#                aidb_commit $conn<br />#                aidb_close $handle<br />#                set handle [aidb_open $conn]<br />#                if {$v != 1} {<br />#                        return 0<br />#                } else {<br />#                        return 1<br />#                }<br />#        }<br />#}<br />#<br />##*********************************************************************<br />## 功能描述：写日志函数到对应tcl文件的.trace文件中<br />## 数据流向：无<br />## 参数说明：<br />##               p_loginfo 日志内容，要打印到.trace文件的内容<br />##               p_errcode 日志错误序号；如果是错误日志，将根据本错误序号找到对应的程序TCL位置；<br />##                           传空表示只是打印信息。错误序号1000以内为保留号，供公共代码使用。<br />## 返回值说明：<br />##               无<br />##*********************************************************************<br />#proc traceLog {p_logInfo p_errCode} {<br />#        global tracefd<br />#        global script<br />#<br />#        if { $p_errCode == "" } {<br />#                puts ${tracefd} "\[[clock format [clock seconds]]\] -&gt; ${p_logInfo} \n"<br />#        } else {<br />#                puts ${tracefd} "\[[clock format [clock seconds]]\] -&gt; ERROR:${p_logInfo} LINE=${p_errCode} \n"<br />#        }<br />#        flush ${tracefd}<br />#}<br />#<br />#<br />#<br />#<br />##*********************************************************************<br />## 功能描述：功能同_exeSql，执行成功则提交数据库，执行失败则返回出错信息<br />## 数据流向：无<br />## 参数说明：<br />##               sqlStr：                表示将执行的sql<br />##               errCode：               表示sql执行的返回码，在一个程序里面应该唯一（递增），用于唯一标示执行的sql<br />##<br />## 返回值说明：<br />##               errmsg 执行失败<br />##               0      执行成功<br />## 创建人：  shiquanzhong 20090319<br />##*********************************************************************<br />#proc _exeSql2 {p_sqlStr p_errCode p_isReturn p_isCommit} {<br />#        global conn<br />#        global handle<br />#<br />#        traceLog "=======       开始执行SQL语句 =======" ""<br />#        traceLog ${p_sqlStr} ""<br />#        if [catch { aidb_sql ${handle} ${p_sqlStr} } errmsg ] {<br />#    traceLog [string range ${errmsg} 30 [string length ${errmsg}] ] ${p_errCode}<br />#    if { ${p_isReturn} == 1 } {<br />#        return $errmsg<br />#    }<br />#  }<br />#  if { ${p_isCommit} == 1 } {<br />#        aidb_commit ${conn}<br />#  }<br />#  traceLog "=======     SQL语句执行结束 =======" ""<br />#        return 0<br />#}<br />#<br />##*********************************************************************<br />## 功能描述：功能同exeSql，执行成功则提交数据库，失败则返回出错信息<br />## 数据流向：无<br />## 参数说明：<br />##               sqlStr：                表示将执行的sql<br />##               errCode：               表示sql执行的返回码，在一个程序里面应该唯一（递增），用于唯一标示执行的sql<br />##<br />## 返回值说明：<br />##               errmsg 执行失败<br />##               0      执行成功<br />## 创建人：  shiquanzhong 20090319<br />##*********************************************************************<br />#proc exeSql2 {p_sqlStr p_errCode} {<br />#        set rt [ _exeSql2 $p_sqlStr $p_errCode 1 1 ]<br />#        if {${rt} == 0 } {<br />#           return 0<br />#           } else {<br />#            return $rt<br />#     }<br />#}<br />#<br />#<br />##*********************************************************************<br />## 功能描述：获取某表记录条数<br />## 数据流向：无<br />## 参数说明：获取条数的表名<br />## 返回值说明：<br />##               n  条数<br />##               -1 获取时出错<br />##*********************************************************************<br />#proc getTabRecNum {p_tabName} {<br />#        global conn<br />#        global handle<br />#<br />#        # 检查表<br />#        set sqlstat "select count(1) from $p_tabName"<br />#        if [catch {aidb_sql $handle $sqlstat} errmsg] {<br />#                trace_sql $errmsg  999<br />#                # 如果语句执行出错，返回-1<br />#                return -1<br />#        } else {<br />#                set v [ aidb_fetch $handle ]<br />#                aidb_commit $conn<br />#                aidb_close $handle<br />#                set handle [aidb_open $conn]<br />#                # 否则返回条数<br />#                return $v<br />#        }<br />#}<br />#<br />##*********************************************************************<br />## 功能描述：把字符串转换为数据(为了解决08-&gt;8这种情况,08在TCL中不识别)<br />## 数据流向：无<br />## 参数说明：字符串(数字字符串)<br />## 返回值说明：<br />##               n  条数<br />##               -1 获取时出错<br />##*********************************************************************<br />#proc getNum {p_string} {<br />#        global conn<br />#        global handle<br />#<br />#        # 检查表<br />#        set sqlstat "select int($p_string) from information_schema.SYS_SCN"<br />#        if [catch {aidb_sql $handle $sqlstat} errmsg] {<br />#                trace_sql $errmsg  999<br />#                # 如果语句执行出错，返回-1<br />#                return -1<br />#        } else {<br />#                set v [ aidb_fetch $handle ]<br />#                aidb_commit $conn<br />#                aidb_close $handle<br />#                set handle [aidb_open $conn]<br />#                # 否则返回条数<br />#                return $v<br />#        }<br />#}<br />#<br />##*********************************************************************<br />## 功能描述：上月同期<br />## 数据流向：无<br />## 参数说明：字符串(数字字符串)<br />## 返回值说明：<br />##               n  条数<br />##               -1 获取时出错<br />##*********************************************************************<br />#proc getLastMonPeriod {p_string} {<br />#        global conn<br />#        global handle<br />#<br />#        # 检查表<br />#        set sqlstat "select date(‘$p_string‘) - 1 month from information_schema.SYS_SCN"<br />#        if [catch {aidb_sql $handle $sqlstat} errmsg] {<br />#                trace_sql $errmsg  999<br />#                # 如果语句执行出错，返回-1<br />#                return -1<br />#        } else {<br />#                set vir_v [ aidb_fetch $handle ]<br />#                aidb_commit $conn<br />#                aidb_close $handle<br />#                set handle [aidb_open $conn]<br />#                # 返回日期<br />#                return ${vir_v}<br />#        }<br />#}<br />#<br />#<br />##****************************************************<br />## 更新sp商code<br />## 返回：-1 更新失败             0 更新成功<br />##****************************************************<br />#proc updSpCode {} {<br />#        global conn<br />#        global handle<br />#<br />#        set tabNm [string toupper dim_ismg_svccode2]<br />#        set ret [isTabExist $tabNm]<br />#        if {$ret == 0} {<br />#                set sqlstat "<br />#                        CREATE TABLE DIM_ISMG_SVCCODE2  (<br />#                                SVCCODE_ID CHAR(15) NOT NULL ,<br />#                                BEGIN_TIME DATE NOT NULL ,<br />#                                END_TIME DATE NOT NULL ,<br />#                                ACTIVE_FLAG SMALLINT ,<br />#                                SVCCODE_NAME CHAR(64) NOT NULL ,<br />#                                SP_DESC CHAR(6) NOT NULL ,<br />#                                DESC_TXT VARCHAR(64) ,<br />#                                SP_TYPE CHAR(1) )<br />#                        PARTITIONING KEY (SP_DESC)  USING HASHING<br />#                        IN TBS_DIM<br />#                "<br />#                if [catch {aidb_sql $handle $sqlstat} errmsg] {<br />#                        trace_sql $errmsg  1000<br />#                        return -1<br />#                } else {<br />#                        aidb_commit $conn<br />#                }<br />#        }<br />#        # 首先清空sp商维表<br />#        set sqlstat "delete from DIM_ISMG_SVCCODE2"<br />#        puts $sqlstat<br />#        if [catch {aidb_sql $handle $sqlstat} errmsg] {<br />#                trace_sql $errmsg  1000<br />#                return -1<br />#        } else {<br />#                aidb_commit $conn<br />#        }<br />#<br />#        # 然后插入st_nbmont_swmk_dm中的sp商代码<br />#        #2005-11-21修改,将短信SP代码sp_type=1,其它SP代码写为2<br />#        set sqlstat "<br />#                insert into DIM_ISMG_SVCCODE2<br />#                        select distinct ‘0‘,‘2004-01-01‘,‘2004-01-01‘,1,‘‘,char(sp_code),‘‘,‘1‘<br />#                        from st_nbmont_swmk_dm where busi_type=1<br />#        "<br />#        puts $sqlstat<br />#        if [catch {aidb_sql $handle $sqlstat} errmsg] {<br />#                trace_sql $errmsg  1000<br />#                return -1<br />#        } else {<br />#                aidb_commit $conn<br />#        }<br />#                set sqlstat "<br />#                insert into DIM_ISMG_SVCCODE2<br />#                        select distinct ‘0‘,‘2004-01-01‘,‘2004-01-01‘,1,‘‘,char(sp_code),‘‘,‘2‘<br />#                        from st_nbmont_swmk_dm where busi_type&lt;&gt;1<br />#        "<br />#        puts $sqlstat<br />#        if [catch {aidb_sql $handle $sqlstat} errmsg] {<br />#                trace_sql $errmsg  1000<br />#                return -1<br />#        } else {<br />#                aidb_commit $conn<br />#        }<br />#        return 0<br />#}<br />#<br />##*********************************************************************<br />## 功能描述：runstats一个表<br />## 数据流向：无<br />## 参数说明：<br />##                       p_tabNm 表名（格式：schema_name.table_name）<br />## 返回值说明：<br />##*********************************************************************<br />#proc runstatsTab {p_tabNm} {<br />#        traceLog "=======       开始执行runstats $p_tabNm  ======" ""<br />#        exec db2 connect to ngcqdw<br />#        traceLog "db2 runstats on table $p_tabNm and index all" ""<br />#        exec db2 runstats on table $p_tabNm and index all<br />#        exec db2 terminate<br />#        traceLog "=======       结束执行runstats $p_tabNm  ======" ""<br />#}<br />#<br />#<br />##*********************************************************************<br />## 功能描述：执行sql，执行后将返回成功失败标志，不提交数据库<br />## 数据流向：无<br />## 参数说明：<br />##               sqlStr：                表示将执行的sql<br />##               errCode：               表示sql执行的返回码，在一个程序里面应该唯一（递增），用于唯一标示执行的sql<br />##<br />## 返回值说明：<br />##               -1 执行失败<br />##               0 执行成功<br />##*********************************************************************<br />#proc exeSqlNoCommit {p_sqlStr p_errCode} {<br />#        set rt [ _exeSql $p_sqlStr $p_errCode 1 0 ]<br />#        return $rt<br />#}<br />##*********************************************************************<br />## 功能描述：激活不记录日志开关<br />## 数据流向：无<br />## 参数说明：<br />##               table_str：     表示激活不记录日志开关的目标表<br />##               errCode：               表示sql执行的返回码，在一个程序里面应该唯一（递增），用于唯一标示执行的sql<br />##<br />## 返回值说明：<br />##               -1 执行失败<br />##               0 执行成功<br />##*********************************************************************<br />#proc notLogInit {table_str p_errCode} {<br />#        set p_sqlStr "alter table ${table_str} activate not logged initially"<br />#        set rt [ _exeSql $p_sqlStr $p_errCode 1 0 ]<br />#        return $rt<br />#}<br />#<br />##*********************************************************************<br />## 功能描述：清空表同时不记录日志<br />## 数据流向：无<br />## 参数说明：<br />##               table_str：     表示需要清空的目标表<br />##               errCode：               表示sql执行的返回码，在一个程序里面应该唯一（递增），用于唯一标示执行的sql<br />##<br />## 返回值说明：<br />##               -1 执行失败<br />##               0 执行成功<br />##*********************************************************************<br />#proc truncatTab {table_str p_errCode} {<br />#        set p_sqlStr "alter table ${table_str} activate not logged initially with empty table"<br />#        set rt [ _exeSql $p_sqlStr $p_errCode 1 1 ]<br />#        return $rt<br />#}<br />##*********************************************************************<br />## 功能描述：去年同期<br />## 数据流向：无<br />## 参数说明：字符串(数字字符串)<br />## 返回值说明：<br />##               n  条数<br />##               -1 获取时出错<br />##*********************************************************************<br />#proc getLastYearPeriod {p_string} {<br />#        global conn<br />#        global handle<br />#<br />#        # 检查表<br />#        set sqlstat "select date(‘$p_string‘) - 1 Year from information_schema.SYS_SCN"<br />#        if [catch {aidb_sql $handle $sqlstat} errmsg] {<br />#                trace_sql $errmsg  999<br />#                # 如果语句执行出错，返回-1<br />#                return -1<br />#        } else {<br />#                set v [ aidb_fetch $handle ]<br />#                aidb_commit $conn<br />#                aidb_close $handle<br />#                set handle [aidb_open $conn]<br />#                # 返回日期<br />#                return $v<br />#        }<br />#}<br />#<br />##*********************************************************************<br />## 功能描述：删除表<br />## 数据流向：无<br />## 参数说明：<br />##               table_str：     表示需要删除的目标表<br />##               errCode：               表示sql执行的返回码，在一个程序里面应该唯一（递增），用于唯一标示执行的sql<br />##<br />## 返回值说明：<br />##               -1 执行失败<br />##               0 执行成功<br />##*********************************************************************<br />#proc droptab {table_str p_errCode} {<br />#<br />#        set isExist [ isTabExist ${table_str} ]<br />#        if {$isExist == 0} {<br />#                        return 0<br />#        }<br />#<br />#        set p_sqlStr "alter table ${table_str} activate not logged initially with empty table"<br />#        set rt [ _exeSql $p_sqlStr $p_errCode 1 1 ]<br />#<br />#        if {$rt == -1} {<br />#                        return -1<br />#        }<br />#<br />#        set p_sqlStr "drop table ${table_str}"<br />#        set rt [ _exeSql $p_sqlStr $p_errCode 1 1 ]<br />#        return $rt<br />#}<br />#<br />##*********************************************************************<br />## 功能描述:获取某个日期对应DT表的表名，若当日表，当月表，日期对应周表都不存在则返回-1<br />## 数据流向:无<br />## 参数说明:<br />##               table_str:      DT表的表名，例如 DW_NB_GPRS_DT<br />##               op_time:                传入的数据日期,格式yyyy-MM-dd<br />##<br />## 返回值说明：<br />##               "相关的日月周表中都不存在${op_time}日数据00检查生成此表${table_str}的tcl是否成功执行"<br />##               其它字符串 表示表名 例如:DW_NB_GPRS_DT_2/DW_NB_GPRS_DT/DW_NB_GPRS_DT_201203<br />##*********************************************************************<br />#proc getTabName {table_str op_time} {<br />#                ##获取当前数据月最后一天日期<br />#                set lde_date [ getLastMday ${op_time} ]<br />#                set sde_date  [ formatDate ${op_time} "yyyy-mm-dd" "yyyymmdd" ]<br />#                set sm_date  [ formatDate ${op_time} "yyyy-mm-dd" "yyyymm" ]<br />#<br />#                set query_tab "${table_str}"<br />#<br />#                set sqlbuf "(select 1 from ${query_tab} where OP_TIME=‘${op_time}‘ fetch first 5 rows only) as T"<br />#                set recnum [ getTabRecNum ${sqlbuf} ]<br />#<br />#                if { ${recnum} &lt;= 0 } {<br />#                                ##traceLog "-----${query_tab} 记录条数不对，返回条数=${recnum}--下面检查是否是月末日期，若是月末日期，则进行检查月表，否则检查周表--" ""<br />#                                set tab_virend [ getWeekDay ${op_time} ]<br />#                                if { ${op_time} == ${lde_date} } {<br />#                                                set tab_virend ${sm_date}<br />#                                }<br />#                                set query_tab "${table_str}_${tab_virend}"<br />#<br />#                                ##traceLog "-----检查周或月表记录条数${query_tab} ----" ""<br />#                                set sqlbuf "(select 1 from ${query_tab} where OP_TIME=‘${op_time}‘ fetch first 5 rows only) as T"<br />#                                set recnum [ getTabRecNum ${sqlbuf} ]<br />#                                if { ${recnum} &lt;= 0 } {<br />#                                                ##traceLog "---周或月表--${query_tab} 记录条数不对，返回条数=${recnum}--" ""<br />#                                                set query_tab "|表${table_str}相关${op_time}日数据不存在检查tcl是否执行|"<br />#                                }<br />#                }<br />#                return ${query_tab}<br />#}<br />#<br />##*********************************************************************<br />## 功能描述: 获取当前日期之后若干个月的日期<br />## 数据流向: 无<br />## 参数说明:<br />##               1 基准日期p_optime，格式yyyy-mm-dd<br />##               2 相隔天数month_num，格式数字，无前导0<br />## 返回值说明：<br />##          month_num个月之后的日期,month_num为负数表示month_num个月之前的日期<br />##*********************************************************************<br />#proc getNextMonthsDay {p_optime month_num} {<br />#    global conn<br />#    global handle<br />#<br />#    # 检查表<br />#    set sqlstat "select date(‘${p_optime}‘) + (${month_num}) month from information_schema.SYS_SCN"<br />#    if [catch {aidb_sql $handle $sqlstat} errmsg] {<br />#        trace_sql $errmsg  999<br />#        # 如果语句执行出错，返回-1<br />#        return -1<br />#    } else {<br />#        set v [ aidb_fetch $handle ]<br />#        aidb_commit $conn<br />#        aidb_close $handle<br />#        set handle [aidb_open $conn]<br />#        # 返回日期<br />#        return $v<br />#    }<br />#}<br />#<br />##*********************************************************************<br />## 功能描述:获取形式为 XXXX_yyyyMMdd类型的带8位日期格式的表对应表名上的最新数据日期<br />## 参数说明:<br />##                 p_tabName:    传入的表的除表名上数据日期外的前面一部分字符<br />## 返回值说明:<br />##     返回表名上的最大日期,若查询时候sql报错，则返回传入数据日期<br />##     日期格式为:yyyyMMdd<br />##*********************************************************************<br />#proc getTabMaxDate {p_tabName p_optime} {<br />#    global conn<br />#          global handle<br />#    set sd_date  [ formatDate ${p_optime} "yyyy-mm-dd" "yyyymmdd" ]<br />#    set sqlbuf "select max(right(tabname,8)) as sd_date<br />#          from syscat.tables<br />#          where tabname like upper(‘${p_tabName}%‘)<br />#              and length(trim(tabname))=(length(‘${p_tabName}‘)+8 )<br />#              and right(tabname,8)&gt;=‘${sd_date}‘ with ur"<br />#    traceLog "=======   开始执行SQL语句 =======" ""<br />#          traceLog ${sqlbuf} ""<br />#<br />#    if [catch {aidb_sql $handle $sqlbuf} errmsg] {<br />#        trace_sql $errmsg  999<br />#        return $sd_date<br />#    } else {<br />#        set sd_date [ aidb_fetch $handle ]<br />#        aidb_commit $conn<br />#        aidb_close $handle<br />#        set handle [aidb_open $conn]<br />#        # 返回日期<br />#        return $sd_date<br />#    }<br />#    traceLog "=======   执行SQL语句     结束=======" ""<br />#}<br />#<br />#<br />##*********************************************************************<br />## 功能描述:获取形式为 XXXX_yyyyMMdd类型的带8位日期格式的表对应表名上的最近数据日期<br />## 参数说明:<br />##                 p_tabName:    传入的表的除表名上数据日期外的前面一部分字符<br />## 返回值说明:<br />##     返回表名上的最大日期,若查询时候sql报错，则返回最新的系统时间-1的 日期<br />##     日期格式为:yyyyMMdd<br />##*********************************************************************<br />#proc getTabRecentDate {p_tabName p_optime} {<br />#    set sd_date  [ formatDate ${p_optime} "yyyy-mm-dd" "yyyymmdd" ]<br />#    set lde_date [ getLastMday ${p_optime} ]<br />#    set sde_date [ formatDate ${lde_date} "yyyy-mm-dd" "yyyymmdd" ]<br />#    set sdf_date [ formatDate ${p_optime} "yyyy-mm-dd" "yyyymm" ]<br />#    set sdf_date "${sdf_date}01"<br />#    global conn<br />#          global handle<br />#    set sqlbuf "select  max(right(tabname,8)) as sd_date<br />#          from syscat.tables<br />#          where tabname like upper(‘${p_tabName}%‘)<br />#              and length(trim(tabname))=(length(‘${p_tabName}‘)+8 )<br />#              and right(tabname,8)&lt;=‘${sde_date}‘<br />#              and right(tabname,8)&gt;=‘${sdf_date}‘<br />#              with ur"<br />#    traceLog "=======   开始执行SQL语句 =======" ""<br />#          traceLog ${sqlbuf} ""<br />#<br />#    if [catch {aidb_sql $handle $sqlbuf} errmsg] {<br />#        trace_sql $errmsg  999<br />#        return $sd_date<br />#    } else {<br />#        set sd_date [ aidb_fetch $handle ]<br />#        aidb_commit $conn<br />#        aidb_close $handle<br />#        set handle [aidb_open $conn]<br />#        # 返回日期<br />#        return $sd_date<br />#    }<br />#    traceLog "=======   执行SQL语句     结束=======" ""<br />#}<br />#<br />#<br />#<br />##*********************************************************************<br />## 功能描述:获取形式为 XXXX_yyyyMMdd类型的带8位日期格式的表对应数据日期的表,获取不到当日的表就取当前日期对应的月底表，若未到月底则获取最新的数据表<br />## 参数说明:<br />##                 p_tabName:    传入的表的除表名上数据日期外的前面一部分字符<br />##     p_optime: 数据日期<br />##     ismaxdate: 在获取不到当日表或者月底表的时候，是否获取最新的表.1,获取最新的表;0,不获取最新的表<br />## 返回值说明:<br />##     返回传入数据日期对应的数据表,若获取不到则取月底表，若月底日期大于当前系统日期-1，则获取最新日期的数据表，<br />##         若最新的数据日期小于当前数据日期对应的月初01号，则报错返回数据日期对应的表<br />##     日期格式为:yyyyMMdd<br />##*********************************************************************<br />#proc getRecentTab {p_tabName p_optime ismaxdate} {<br />#<br />#    set lde_date [ getLastMday ${p_optime} ]<br />#    set sd_date  [ formatDate ${p_optime} "yyyy-mm-dd" "yyyymmdd" ]<br />#          set sde_date  [ formatDate ${lde_date} "yyyy-mm-dd" "yyyymmdd" ]<br />#<br />#<br />#    set var_tab "${p_tabName}${sd_date}"<br />#    set isExist [ isTabExist ${var_tab} ]<br />#    ###若数据日期对应的表不存在，则进行获取月底日期的表<br />#    if { ${isExist} == 0 } {<br />#        ##取系统时间<br />#        set sys_ld_date [ exec date +%Y-%m-%d ]<br />#        ##取系统时间的前一天当做系统时间，方便后面做判断处理<br />#        set sys_ld_date [ getPreDay ${sys_ld_date} ]<br />#        set sys_sd_date [ formatDate ${sys_ld_date} "yyyy-mm-dd" "yyyymmdd" ]<br />#<br />#        ###若数据日期对应月末日期小于系统时间-1，则返回月末日期对应的数据表<br />#        if { ${sde_date} &lt; ${sys_sd_date} } {<br />#            set var_tab "${p_tabName}${sde_date}"<br />#            set isExist [ isTabExist ${var_tab} ]<br />#            if { ${isExist} == 0 } {<br />#                if { ${ismaxdate} == 1 } {<br />#                    set max_sd_date [ getTabMaxDate ${p_tabName} ${p_optime} ]<br />#                } else {<br />#                    set max_sd_date [ getTabRecentDate ${p_tabName} ${p_optime} ]<br />#                }<br />#                set var_tab "${p_tabName}${max_sd_date}"<br />#            }<br />#        } else {<br />#            set max_sd_date [ getTabRecentDate ${p_tabName} ${p_optime} ]<br />#            set var_tab "${p_tabName}${max_sd_date}"<br />#        }<br />#    }<br />#<br />#    return ${var_tab}<br />#<br />#}<br />#<br />#<br />#<br />#<br />##*********************************************************************<br />## 功能描述：获取前数月同期<br />## 数据流向：无<br />## 参数说明：<br />##         1 基准日期p_optime，格式yyyy-mm-dd<br />##         2 多少月 数字<br />## 返回值说明：<br />##    qianxl add 20140819<br />##*********************************************************************<br />#proc getNMonPeriod {p_string p_cnt} {<br />#        global conn<br />#        global handle<br />#<br />#        # 检查表<br />#        set sqlstat "select date(‘$p_string‘) - ${p_cnt} month from information_schema.SYS_SCN"<br />#        if [catch {aidb_sql $handle $sqlstat} errmsg] {<br />#                trace_sql $errmsg  999<br />#                # 如果语句执行出错，返回-1<br />#                return -1<br />#        } else {<br />#                set v [ aidb_fetch $handle ]<br />#                aidb_commit $conn<br />#                aidb_close $handle<br />#                set handle [aidb_open $conn]<br />#                # 返回日期<br />#                return $v<br />#        }<br />#}<br />#<br />##*********************************************************************<br />## 功能描述: 获取上个季度<br />## 数据流向: 无<br />## 参数说明:<br />##               1 基准日期p_optime，格式yyyy-mm-dd<br />##<br />## 返回值说明：<br />##          返回上个季度年及在当年属于第几季度<br />##   qianxl add 20140819<br />##*********************************************************************<br />#proc getPreseason {p_optime} {<br />#    global conn<br />#    global handle<br />#<br />#    # 检查表<br />#    set sqlstat "select date(‘${p_optime}‘) -3 month from information_schema.SYS_SCN"<br />#    if [catch {aidb_sql $handle $sqlstat} errmsg] {<br />#        trace_sql $errmsg  999<br />#        # 如果语句执行出错，返回-1<br />#        return -1<br />#    } else {<br />#        set v [ aidb_fetch $handle ]<br />#        aidb_commit $conn<br />#        aidb_close $handle<br />#        set handle [aidb_open $conn]<br />#        # 返回日期<br />#        scan $v  "%04s-%02s-%02s" tyear tmonth tday<br />#<br />#        set sqlstat "select int(ceiling(${tmonth}*1.00/3))  from information_schema.SYS_SCN"<br />#        if [catch {aidb_sql $handle $sqlstat} errmsg] {<br />#        trace_sql $errmsg  999<br />#        # 如果语句执行出错，返回-1<br />#        return -1<br />#    } else {<br />#        set v [ aidb_fetch $handle ]<br />#        aidb_commit $conn<br />#        aidb_close $handle<br />#        set handle [aidb_open $conn]<br />#        # 返回日期<br />#        return ${tyear}${v}<br />#    }<br />#<br />#    }<br />#}<br />#<br />#<br />##*********************************************************************<br />## 功能描述: 获取上个季度三个月份<br />## 数据流向: 无<br />## 参数说明:<br />##               1 基准日期p_optime，格式yyyy-mm-dd<br />##<br />## 返回值说明：<br />##          返回上季度的三个月份<br />##   qianxl add 20140819<br />##*********************************************************************<br />#proc getPreSMon {p_optime} {<br />#    global conn<br />#    global handle<br />#<br />#    # 检查表<br />#    set sqlstat "select date(‘${p_optime}‘) -3 month from information_schema.SYS_SCN"<br />#    if [catch {aidb_sql $handle $sqlstat} errmsg] {<br />#        trace_sql $errmsg  999<br />#        # 如果语句执行出错，返回-1<br />#        return -1<br />#    } else {<br />#        set v [ aidb_fetch $handle ]<br />#        aidb_commit $conn<br />#        aidb_close $handle<br />#        set handle [aidb_open $conn]<br />#        scan $v  "%04s-%02s-%02s" tyear tmonth tday<br />#<br />#        set sqlstat "select int(ceiling(${tmonth}*1.00/3))  from information_schema.SYS_SCN"<br />#        if [catch {aidb_sql $handle $sqlstat} errmsg] {<br />#        trace_sql $errmsg  999<br />#        # 如果语句执行出错，返回-1<br />#        return -1<br />#    } else {<br />#        set v [ aidb_fetch $handle ]<br />#        aidb_commit $conn<br />#        aidb_close $handle<br />#        set handle [aidb_open $conn]<br />#<br />#       # return $v<br />#      if { $v == 1 } {<br />#      return  ${tyear}01-${tyear}02-${tyear}03<br />#        }<br />#      if { $v == 2 } {<br />#      return  ${tyear}04-${tyear}05-${tyear}06<br />#        }<br />#      if { $v == 3 } {<br />#      return  ${tyear}07-${tyear}08-${tyear}09<br />#        }<br />#      if { $v == 4 } {<br />#      return  ${tyear}10-${tyear}11-${tyear}12<br />#        }<br />#    }<br />#    }<br />#}<br />#<br />#<br />##*********************************************************************<br />## 功能描述: 获取本季度三个月份<br />## 数据流向: 无<br />## 参数说明:<br />##               1 基准日期p_optime，格式yyyy-mm-dd<br />##<br />## 返回值说明：<br />##          返回本季度的三个月份<br />##   qianxl add 20140819<br />##*********************************************************************<br />#proc getTheSMon {p_optime} {<br />#    global conn<br />#    global handle<br />#<br />#        scan $p_optime  "%04s-%02s-%02s" tyear tmonth tday<br />#<br />#        set sqlstat "select int(ceiling(${tmonth}*1.00/3))  from information_schema.SYS_SCN"<br />#        if [catch {aidb_sql $handle $sqlstat} errmsg] {<br />#        trace_sql $errmsg  999<br />#        # 如果语句执行出错，返回-1<br />#        return -1<br />#    } else {<br />#        set v [ aidb_fetch $handle ]<br />#        aidb_commit $conn<br />#        aidb_close $handle<br />#        set handle [aidb_open $conn]<br />#<br />#       # return $v<br />#      if { $v == 1 } {<br />#      return  ${tyear}01-${tyear}02-${tyear}03<br />#        }<br />#      if { $v == 2 } {<br />#      return  ${tyear}04-${tyear}05-${tyear}06<br />#        }<br />#      if { $v == 3 } {<br />#      return  ${tyear}07-${tyear}08-${tyear}09<br />#        }<br />#      if { $v == 4 } {<br />#      return  ${tyear}10-${tyear}11-${tyear}12<br />#        }<br />#    }<br />#<br />#}<br />##*********************************************************************<br />## 功能描述: 获取最新数据表<br />## 数据流向: 无<br />## 参数说明:<br />##               表名<br />##<br />## 返回值说明：<br />##          返回该表的最新数据日期<br />##   qianxl add 20141120<br />##*********************************************************************<br />#proc getnewTab {Tab_name} {<br />#    global conn<br />#    global handle<br />#<br />#     set sqlstat "select tabname from syscat.tables where tabname like ‘${Tab_name}%‘ order by 1 desc fetch first 1 rows only with ur"<br />#        if [catch {aidb_sql $handle $sqlstat} errmsg] {<br />#        trace_sql $errmsg  999<br />#        # 如果语句执行出错，返回-1<br />#        return -1<br />#    } else {<br />#        set v [ aidb_fetch $handle ]<br />#        aidb_commit $conn<br />#        aidb_close $handle<br />#        set handle [aidb_open $conn]<br />#        return $v<br />#<br />#    }<br />#<br />#}<br />#<br />#<br />##*********************************************************************<br />## 功能描述：去年同期 new<br />## 数据流向：无<br />## 参数说明：字符串(数字字符串)<br />## 返回值说明：<br />##               n  条数<br />##               -1 获取时出错<br />##*********************************************************************<br />#proc getLastYearPeriod1 {p_optime} {<br />#        set year 0<br />#        set month 0<br />#        set day 0<br />#        scan $p_optime "%04d-%02d-%02d" year month day<br />#<br />#        set year [expr $year -1]<br />#<br />#        #若是1月<br />#        if { $month == 2 &amp;&amp; $day ==29 } {<br />#                #返回去年2月最后一天<br />#                set day [ getMonthDays ${year}-${month}-01 ]<br />#        }<br />#<br />#        set month [format "%02d" $month]<br />#        set day [format "%02d" $day]<br />#<br />#        return $year-$month-$day<br />#}</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-15 12:28:30 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>lib.tcl的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3ODVd94.html" rel="bookmark">freewrap&mdash;&mdash;将tcl&sol;tk脚本转变为可执行文件</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				FreeWrap可以把TCL/TK的脚本和二进制文件打包成应用程序,FreeWrap将所有的文件组合成一个单独的可执行文件. FreeWrap的原理是把脚本和tcl/tk解释器和库文件都打包在一个文件当中,做成一个可执行程序.生成的可执行文件实际上是一个压缩包,里面包含有需要使用的所有内容.不同的版本对应不同的tcl/tk版本,由于原始的tcl/tk版本只包括一些基本的库,所以如果需要使用更多的库,需要额外添加到文件中,还需要注意添加的方法和调用的顺序,如果是二进制的库就更麻烦了,需要额外的添加			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MzrK7OM.html" rel="bookmark">CCIE学习笔记之EEM</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				当内存使用到一定程度生成日志并发邮件: 注册applet并进入applet配置模式: Router(config)# event manager appletmemory-fail 定义触发事件: event snmp oid oid-value get-type{exact|next} entry-op operator entry-val entry-value[exit-comb| and}] [exit-opoperator] [exit-val exit-value] [exit-ti			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/pMPRgP3.html" rel="bookmark">linux 基础学习编译安装php&plus;mysql&plus;python3&plus;memcached&plus;radis&plus;rabbitmq&plus;libevent&plus;tcl&plus;gcc&plus;erlang</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				CentOS 6.9 编译安装 Nginx+PHP+MYSQL 0x01 环境约束 源码位置 /home/[用户文件夹] 源码编译安装位置  /usr/local/[软件名] CentOS6.9 x86 - 64 最小化安装 配置好网络 用户 使用Xshell登录 0x02 软件下载 内网地址: http://192.168.20.252/src/php.tar.gz http://192.168.20.252/src/cmake.tar.gz http://192.168.20.252/src			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/QM6RoJM.html" rel="bookmark">Python著名的lib和开发框架（均为转载）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第一,https://github.com/vinta/awesome-python Awesome Python A curated list of awesome Python frameworks, libraries, software and resources. Inspired by awesome-php. Awesome Python Admin Panels Algorithms and Design Patterns Anti-spam Asset Management A			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0x8RVD0.html" rel="bookmark">Tcl与Design Compiler （十三）&mdash;&mdash;Design Compliler中常用到的命令（示例）总结</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文如果有错,欢迎留言更正:此外,转载请标明出处 http://www.cnblogs.com/IClearner/  ,作者:IC_learner 本文将描述在Design Compliler中常用到的命令,这些命令按照流程的顺序进行嵌套讲解,主要是列举例子:大概的讲解布局如下所示: 大概有11个部分,下面我们逐个部分进行(简单的)介绍的举例. 1.tcl的命令和结构 tcl的命令和结构请参照第二节的内容: http://www.cnblogs.com/IClearner/p/6617207.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPdx9yM.html" rel="bookmark">TCL&colon;使用、添加库文件</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				&gt;直接引用工具自带的库文件 通过指令: 1.1查看能直接调用的库文件路径 #可以查到工具默认库文件路径,一般包括回显中的路径以及回显中路径的父路径. info library #D:/Script.NET/V2/Interps/Tcl/Lib/tcl8.4 1.2.在上一步的路径下找找没有自己需要的库,通过指令: package require xxx 引用,一般直接写tcl文件名即可,如果不对,查看pkgIndex.tcl里package ifneeded 后边的名称. &gt;引用别人的库文件或			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Myj9Gj0.html" rel="bookmark">Linux Tcl和Expect的安装</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.先安装Tcl 1.下载:tcl版本 8.4.19 http://sourceforge.net/projects/tcl/files/Tcl/8.4.19/tcl8.4.19-src.tar.gz/download 2.解压缩源码包 tar xfvz tcl8.4.19-src.tar.gz 3.安装配置 #cd tcl8.4.19/unix #./configure --prefix=/usr/local/tcl --enable-shared #make #make install 4.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3qQ6DW3.html" rel="bookmark">Tcl与Design Compiler （三）&mdash;&mdash;DC综合的流程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文属于原创手打(有参考文献),如果有错,欢迎留言更正:此外,转载请标明出处 http://www.cnblogs.com/IClearner/  ,作者:IC_learner 1.基本流程概述 首先给三个图,一个图是高层次设计的流程图: 下面是我对这张图的理解: ① 设计之前,准备好库.HDL代码的思想.约束生成:然后根据设计思想用 RTL 源码详细地.完整地为设计建立模型.定义设计中寄存器结构和数目.定义设计中的组合电路功能.定义设计中寄存器时钟等等的设计规格和实现. ② 完成 RTL 源码			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4J8XRB0.html" rel="bookmark">【NS2】TCL debug  （转载）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.使用NS2进行模拟,就不可避免的会接触TCL/OTCL和C/C++.两者配合使用.一般设置场景啊,业务流啊,都使用TCL/OTCL来编写脚 本.要进行路由实验模拟的话,同一类的实验,这些脚本基本上是差不多的.所以其实没有必要在这种脚本语言上花费太多的时间.最主要的就是用C/C++来实 现自己的路由算法,这才是考验你基本功的地方. 2.算法出来之后,就开始模拟了.要使得自己写的新路由算法能在NS2上跑,就需 要修改一些文件,使得NS2能够认识你的路由算法.主要包括NS2_HOME/ns-2.3			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/9495Nn4.html" rel="bookmark" class="title">js 秒杀</a>
					<div>
						秒杀活动页面 &lt;!DOCTYPE HTML&gt; &lt;html&gt; &lt;head&gt; &lt;meta http-equiv=&quot;Content-Type&quot;  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/V02vln0.html" rel="bookmark" class="title">jetty启动https</a>
					<div>
						&lt;Configure id=&quot;Server&quot; class=&quot;org.eclipse.jetty.server.Server&quot;&gt; &lt;!-- if ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPN7mz3.html" rel="bookmark" class="title">Arduino &plus; SmartAirFilter 制作智能感应的 PM 空气净化器</a>
					<div>
						先说 SmartAirFilters 知道 SmartAirFilters 源自微博上转发的非常火的那个帖子,和动辄七八千元的商用产品比,几百元的 SmartAirFilters(下面简称电扇) 确实 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wR5PY0.html" rel="bookmark" class="title">Ajax&plus;php实现动态显示时间</a>
					<div>
						前端代码: &lt;script type=&quot;text/javascript&quot;&gt; var xmlHttp; function createXMLHttpRequest(){  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/415k2k4.html" rel="bookmark" class="title">JVM中对象的销毁</a>
					<div>
						1.可达性分析算法: 可达性分析算法用来寻找将要销毁的对象,它的基本思路是:通过一系列的称为“GC ROOTs”的对象作为起始点,从这些节点开始向下搜索,搜索所走过的路径成为引用链,当一个对象到GC  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vZ2P63.html" rel="bookmark" class="title">运用web开发技能就能够轻松的完结web app开发</a>
					<div>
						晋级较简略 晋级不需求通知用户.用户彻底没有感觉服务端更新文件即可. 维护比较轻松 和一般的web相同.其实即是一个站点维护比较简略. Webapp说白了即是一个对于IphoneAndroid优化后的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoxZlP0.html" rel="bookmark" class="title">活动目录的优点</a>
					<div>
						活动目录的相关概念 活动目录 是Windows的一种服务,方便管理 是一个目录数据库,集中存储着整个Windows网络中的用户账号.组.计算机.共享文件夹等对象的相关信息 优点 集中管理: 相当于图书 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Myl2zm4.html" rel="bookmark" class="title">2007Hanoi双塔问题</a>
					<div>
						题目描述 Description 给定A.B.C三根足够长的细柱,在A柱上放有2n个中间有孔的圆盘,共有n个不同的尺寸,每个尺寸都有两个相同的圆盘,注意这两个圆盘是不加区分的(下图为n=3的情形).现 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPwgyv4.html" rel="bookmark" class="title">zbrush模版调控板介绍</a>
					<div>
						今天小编来教大家认识zbrush模版调控板. ZBrush模版的作用象我们了解的所有绘制工具,通过它确定模版周围与涂画或模型的位置,下面是怎样使用默认的 “曲线板”模版或使用自定义形状: 1.打开St ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nPOwX4.html" rel="bookmark" class="title">使用pure-ftpd实现ftp功能</a>
					<div>
						环境:Centos6 工具pure-ftpd 下载地址ftp://ftp.pureftpd.org/pub/pure-ftpd/releases/ 版本pure-ftpd-1.0.42 安装ftp . ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pLEOy4.html" rel="bookmark" class="title">技术学习的困惑与时间管理</a>
					<div>
						做为一名IT人士,在技术学习的过程中总是会遇到很多的问题.这里就从我所会的技术为例,说一说怎么才能够更有效的去学习及时间管理. 我是怎么学习PON 的 大家先不用去管PON是一门什么技术,如果能够遇到 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nL57p4.html" rel="bookmark" class="title">安装percona-xtrabackup一直提示依赖冲突的一个解决办法</a>
					<div>
						我的Mysql是5.6版本,通过自己下载的rpm包执行安装: yum instal percona-xtrabackup-2.1.7-721.rhel6.x86_64.rpm 会出现如下的安装错误提示 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoLKPy0.html" rel="bookmark" class="title">OpenShare：前所未有的开放性</a>
					<div>
						客户总是面临一个选择:开放的企业门户产品 vs 封闭的企业门户产品 市场上大多数企业门户产品是自成一体的其实也就是封闭的,他们不能和企业目录集成,不能和Exchange集成,不能和SAP集成,不能和L ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0K8aoL3.html" rel="bookmark" class="title">Egret Wing3 FTP使用方法</a>
					<div>
						FTP 挺实用的,不用自己去申请sinasea什么的免费空间来测试项目了. 添加FTP服务器配置 默认就行. 指定目录上传至FTP服务器 选择免费云测试空间.然后选择bin-release/web目录 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGDGEG0.html" rel="bookmark" class="title">SQL&lowbar;模糊查询</a>
					<div>
						--'_'匹配单个字符 --'%'匹配多个字符 SELECT * FROM Students WHERE Name LIKE '张%' --查询以'张'开头的记录 SELECT * FROM Stud ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OpyLo4.html" rel="bookmark" class="title">day18&amp;lt&semi;集合框架&plus;&amp;gt&semi;</a>
					<div>
						集合框架(Map集合概述和特点) 集合框架(Map集合的功能概述) 集合框架(Map集合的遍历之键找值) 集合框架(Map集合的遍历之键值对对象找键和值) 集合框架(Map集合的遍历之键值对对象找键和 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBjKOJM.html" rel="bookmark" class="title">Assets&period;xcassets误删后的恢复</a>
					<div>
						一般要是remove Reference,undo就ok了.如果undo没法搞得话,就得手动搞. 1.首先去废纸篓把被删除的目录恢复到原处,也就是项目目录. 2.右键项目主目录名称,选择&quot;A ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49vN7DM.html" rel="bookmark" class="title">iOS开发中的零碎知识点笔记 韩俊强的博客</a>
					<div>
						每日更新关注:http://weibo.com/hanjunqiang  新浪微博 1.关联 objc_setAssociatedObject关联是指把两个对象相互关联起来,使得其中的一个对象作为另外 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzXOp23.html" rel="bookmark" class="title">jQuery颜色面板插件</a>
					<div>
						/** * jQuery颜色面板插件 * * 使用方法:input框的id默认为inputObj,button框的id默认为btnObj,也可以自定义aaa,bbb * 1.初始化颜色面板:$.col ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dDdOg0.html" rel="bookmark" class="title">出差回来--快速排序</a>
					<div>
						被导师派出差加上之前的大摩的面试,两周的时间都在飞机或者火车上,弄的回到学校浮躁,状态不是很好. 调整状态最好的办法就是去做了,今天下午写了一下,一直不愿意写的快速排序算法,分享一下~ public  ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
